/*{{TIDC_Wizard Auto Code Start                                 */
/****************************************************************/
/* don't change anything here until you know what you are doing!*/
/* the plug-in will change all text between the code marks      */
/* without user interaction!                                    */
/*                                                              */
/****************************************************************/

/****************************************************************/
/* software generated by Data Converter Plug-in (DCP)           */
/* based on <C:\CCSTUD~1.1\PLUGINS\AAP_DEV\c6400\d1606_64.h> */
/****************************************************************/
/****************************************************************/

/* ADS1606 Interface Software Version 2.0 for the TMS320C641x   */

/* Copyright (C) 2004- 2006 Texas Instruments Incorporated      */

/* All Rights Reserved                                          */

/*--------------------------------------------------------------*/

/* $Revision: 7 $                         $JustDate: 10/17/06 $ */

/* $Author: A0746714 $                                          */

/****************************************************************/

#ifndef __T1606_FN_H

#define __T1606_FN_H



#define __CSL_AVAILABLE

#include "tidc_api.h"



#include <csl.h>

#include <csl_edma.h>

#include <csl_timer.h>



/****************************************************************/

/* #defines used in the code                                    */

/****************************************************************/

#define ADS1606_BUFOBJECT_FREE     (0x00000000u)

#define ADS1606_BUFOBJECT_INUSE    (0x00000001u)

#define ADS1606_BUFOBJECT_COMPLETE (0x00000002u)



/****************************************************************/

/* defines used for the dc_control function                     */

/****************************************************************/

#define ADS1606_CMD_RESET           (0x00000001)



/****************************************************************/

/* DEFINITIONS FOR THE DMA CHANNEL REGISTERS                    */

/****************************************************************/

/****************************************************************/

/* define for the channel options parameter register OPT        */

/* operating mode: Input                                        */

/* Value: 0x2830 0003                                           */

/* 0010 1000 0011 0000 0000 0000 0000 0011                      */

/* |||| |||| |||| |||| |||| |||| |||| ||||                      */

/* |||| |||| |||| |||| |||| |||| |||| |||+- FS (yes)            */

/* |||| |||| |||| |||| |||| |||| |||| ||+-- LINK (yes)          */

/* |||| |||| |||| |||| |||| |||| |||| |+--- PDTD (disabled)     */

/* |||| |||| |||| |||| |||| |||| |||| +---- PDTS (disabled)     */

/* |||| |||| |||| |||| |||| |||| |||+------ RESERVED            */

/* |||| |||| |||| |||| |||| |+++ +++------- ATCC (0)            */

/* |||| |||| |||| |||| |||| +-------------- RESERVED            */

/* |||| |||| |||| |||| |||+---------------- ATCINT (no)         */

/* |||| |||| |||| |||| |++----------------- TCCM (set by func)  */

/* |||| |||| |||| |||| +------------------- RESERVED            */

/* |||| |||| |||| ++++--------------------- TCC (set by funct)  */

/* |||| |||| |||+-------------------------- TCINT (yes)         */

/* |||| |||| |++--------------------------- DUM (increment)     */

/* |||| |||| +----------------------------- 2DD (no)            */

/* |||| ||++------------------------------- SUM (none)          */

/* |||| |+--------------------------------- 2DS (no)            */

/* |||+-+---------------------------------- ESIZE (16-bit)      */

/* +++------------------------------------- PRI (high)          */

/****************************************************************/

#define ADS1606_EDMAOPT_INPUT_VALUE (0x28300003)



/****************************************************************/

/** \struct TADS1606BUFOBJ

 *  Definition of the buffer object used for double buffering.

 *  This structure is used in the TADS1606 data converter

 *  object.                                                     */

/****************************************************************/

typedef struct

{

/** \var *ptrCallBack

 *  This is the pointer to the callback function, which will be

 *  called once the transfer is complete. Each submitted transfer

 *  can have its own callback function.                         */

/** \var *sBufPtr

 *  Pointer to the buffer, which is used for the transfer (either

 *  read or write). It is the task of the application to allocate

 *  the buffer itself.                                          */

/** \var uiBufSize

 *  This variable holds the number of samples to transfer. No

 *  verification is performed that the number of samples will fit

 *  into the buffer.                                            */

/** \var uiStatus

 *  Signals the status of the buffer. The following values are

 *  possible:

 *      - ADS1606_BUFOBJECT_FREE: Object is not in use

 *      - ADS1606_BUFOBJECT_INUSE: Object is in use, i.e. the

 *        transfer was submitted

 *      - ADS1606_BUFOBJECT_COMPLETE: Object is complete, i.e. the

 *        buffer has been completely transferred. This state is

 *        only available during the interrupt service routine and

 *        the callback function. The ISR will reset this flag to

 *        ADS1606_BUFOBJECT_FREE, as soon as the callback function

 *        returns.                                              */

/****************************************************************/

    void                   (*ptrCallBack)(void *);

    short                  *sBufPtr;

    unsigned int           uiBufSize;

    volatile unsigned int  uiStatus;

} TADS1606BUFOBJ;





/****************************************************************/

/** \struct TADS1606

 *  Definition of the data converter object. This is the main

 *  object to work with.                                        */

/****************************************************************/

typedef struct

{

/** \var f

 *   Structure for the API function pointers.

 *   They are declared in tidc_api.h and defined in tidc_api.c. */

/** \var xferBuffer[2]

 *  This array holds two structures of the type TADS1606BUFOBJ,

 *  which are used to hold information about the buffers

 *  submitted.                                                  */

/** \var hEdmaRead

 *  Handle to the EDMA channel for the data transfer from the

 *  ADS1606 to the memory array. This handle will be created

 *  by the function InitEdma(), which is called during

 *  ADS1606_configure().                                        */

/** \var hEdmaLinkRead

 *  Pointer to the transfer link table of the EDMA. Used, if

 *  a transfer is submitted while another one is ongoing.       */

/** \var hEdmaStop

 *  Pointer to the transfer stop table. Used to bring the EDMA

 *  channel to a halt once a transfer completes (the table

 *  contains all zeroes                                         */

/** \var *adcReadAdr

 *  Pointer to the ADS1606 on the EMIF. Holds the address of the

 *  converter as word address.                                  */

/** \var drdyIntPol

 *  Signals the polarity of the DRDY signal when it arrives

 *  at the DSP. It will be 1, if the DRDY signal is connected

 *  directly to the DSP, and 0, if it is inverted.              */

/** \var iObjectIndex

 *  Holds the index of the last buffer object used.             */

/** \var uiDrdyIntNum

 *  This variable holds the number of the interrupt line of the

 *  DSP, where the DRDY line is connected to.                   */

/** \var emifSetup

 *  Is one, if the EMIF should be setup by the ADS1606_configure()

 *  function and zero otherwise. The value will be set at

 *  startup based on the selection made in the graphical user

 *  interface.                                                  */

/** \var uiFifoLevel

 *  Holds the triggerlevel of the FIFO                          */

/** \var xferInProgress

 *  This value indicates if there is a data transfer ongoing and

 *  can have the following values:

 *      - 0: No transfer is ongoing

 *      - 1: One transfer is ongoing

 *      - 2: One transfer is ongoing and another is submitted.  */

/****************************************************************/

    TTIDC3              f;

    TADS1606BUFOBJ      xferBuffer[2];

    EDMA_Handle         hEdmaRead;

    EDMA_Handle         hEdmaLinkRead;

    EDMA_Handle         hEdmaStop;

    volatile short      *adcReadAdr;

    unsigned int        drdyIntPol;

    int                 iObjectIndex;

    unsigned int        uiDrdyIntNum;

    unsigned int        emifSetup;

    unsigned int        uiFifoLevel;

    volatile int        xferInProgress;

} TADS1606;





/****************************************************************/

/* define external DC object pointer(s)                         */

/****************************************************************/

extern TADS1606 Ads1606_1;



/****************************************************************/

/* function definitions                                         */

/****************************************************************/

DCPAPI TTIDCSTATUS ADS1606_configure(void *pDC);

DCPAPI TTIDCSTATUS ADS1606_control(void *pDC, int iCmd, void *pValue);

DCPAPI TTIDCSTATUS ADS1606_readsample(void *pDC, long *lData);

DCPAPI TTIDCSTATUS ADS1606_writesample(void *pDC, long lData);

DCPAPI TTIDCSTATUS ADS1606_readblock(void *pDC,

                        void *pData,

                        unsigned long ulCount,

                        void (*callback) (void *));

DCPAPI TTIDCSTATUS ADS1606_writeblock(void *pDC,

                        void *pData,

                        unsigned long ulCount,

                        void (*callback) (void *));

DCPAPI TTIDCSTATUS ADS1606_close(void *pDC);

DCPAPI TTIDCSTATUS ADS1606_rblock_finished(void* pDC);



#endif /* __T1606_FN_H                                          */




/****************************************************************/
/* END OF t1606_fn.h                                             */
/****************************************************************/
/*TIDC_Wizard Auto Code End}}*/
